﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;

namespace Elight.Utility.Code
{
    /// <summary>
    /// 消息
    /// </summary>
    [Serializable]
    [DataContract]
    public class Result
    {
        /// <summary>
        /// 成功/失败
        /// </summary>
        [DataMember]
        public bool IsSucceed { get; set; }

        /// <summary>
        /// 消息
        /// </summary>
        [DataMember]
        public string Message { get; set; }
        /// <summary>
        /// 消息
        /// </summary>
        [DataMember]
        public dynamic result { get; set; }
    }

    /// <summary>
    /// 消息
    /// </summary>
    [Serializable]
    [DataContract]
    public class ResultData : Result
    {
        /// <summary>
        /// 数据
        /// </summary>
        [DataMember]
        public string Data { get; set; }
    }

    /// <summary>
    /// 处理结果
    /// </summary>
    /// <typeparam name="T">扩展数据</typeparam>
    [Serializable]
    [DataContract]
    public class Result<T> : Result
    {
        /// <summary>
        /// 扩展数据
        /// </summary>
        [DataMember]
        public new T result { get; set; }
    }
}
